Projects
POST
projects/{projectId}/costs:batch-create
Creates multiple indirect cost items on the project. Max 200 items per call.
Resource Information
| Method and URI | POST https://developer.api.autodesk.com/construction/buildingconnected/v2/projects/{projectId}/costs:batch-create |
| Authentication Context | User context required |
| Required OAuth Scopes | data:write |
| Data Format | JSON |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow. |
| Content-Type* string | Must be application/json |
* Required
Request
URI Parameters
| projectId string | The ID of a BuildingConnected project. |
Request
Body Structure
An array of indirect cost items to create. Max 200 items per call.
Note that cost entries must have unique combined section, code and name values.
Expand all
| section* string | The project section to which the cost applies.
A project has these sections by default, but any name can be provided to create a new section:
|
| code* string | An identifying code associated with the cost. |
| name* string | The name of the cost. |
| calculationType* enum:string | The method by which the cost is calculated. Possible values:
|
| calculation* one of | The calculation data appropriate for each of the calculation types. |
| 0* object | The calculation data for the LUMP_SUM type. |
| amount* number | The lump sum amount in the specified project.defaultCurrency. |
| 1* object | The calculation data for the PERCENTAGE type. |
| percent* number | The percentage to apply (with 0 being 0% and 1 being 100%). |
| 2* object | The calculation data for the RATE type. |
| rate number | The per-unit amount (the rate). |
| quantity number | The number of units. |
| unitType* enum:string | The type of unit.
Possible values: HOUR, DAY, WEEK, MONTH, EACH, ACRE, AMP, BOARD_FT, CUBIC_FT, CUBIC_METER, CUBIC_YARD, FLOOR, GALLON, GROSS_SQFT, KILOGRAM, LINEAR_FT, LINEAR_METER, LINEAR_YARD, LITER, LOT, METRIC_TON, POUNDS, RISER, SQUARE_FT, SQUARE_METER, SQUARE_INCH, SQUARE_YARD, STALL, STOPS, TON, WATT |
* Required
Response
HTTP Status Code Summary
| 201 Created | Created |
| 400 Bad Request | The parameters of the requested operation are invalid. |
| 401 Unauthorized | The provided bearer token is not valid. |
| 403 Forbidden | The user or service represented by the bearer token does not have permission to perform this operation. |
| 404 Not Found | The requested resource could not be found. |
| 429 Too Many Requests | Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait. |
| 500 Internal Server Error | An unknown error occurred on the server. |
Response
Body Structure (201)
Expand all
| results array: object | List of indirect costs that were successfully created. |
| id string | The unique ID of the cost.
Max length: 24 |
| section string | The project section to which the cost applies. |
| code string | An identifying code associated with the cost. |
| name string | The name of the cost. |
| calculationType enum:string | The method by which the cost is calculated. Possible values:
|
| calculation one of | The calculation data for the cost and calculationType. |
| 0 object | The calculation data for the LUMP_SUM type. |
| amount number | The lump sum amount in the specified project.defaultCurrency. |
| 1 object | The calculation data for the PERCENTAGE type. |
| percent number | The percentage to apply (with 0 being 0% and 1 being 100%). |
| 2 object | The calculation data for the RATE type. |
| rate number | The per-unit amount (the rate). |
| quantity number | The quantity of units. |
| unitType enum:string | The type of unit.
Possible values: HOUR, DAY, WEEK, MONTH, EACH, ACRE, AMP, BOARD_FT, CUBIC_FT, CUBIC_METER, CUBIC_YARD, FLOOR, GALLON, GROSS_SQFT, KILOGRAM, LINEAR_FT, LINEAR_METER, LINEAR_YARD, LITER, LOT, METRIC_TON, POUNDS, RISER, SQUARE_FT, SQUARE_METER, SQUARE_INCH, SQUARE_YARD, STALL, STOPS, TON, WATT |
Example
Created
Request
curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/projects/:projectId/costs:batch-create' \
-X 'POST' \
-H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
-H 'Content-Type: application/json' \
-d '[
{
"section": "Insurance",
"code": "1234",
"name": "Insurance Cost",
"calculationType": "LUMP_SUM",
"calculation": {
"amount": 1000
}
}
]'
Show More
Response
{
"results": [
{
"id": "61a104b87e392d56e1e4b4ad",
"section": "Insurance",
"code": "1234",
"name": "Insurance Cost",
"calculationType": "LUMP_SUM",
"calculation": {
"amount": 1000
}
}
]
}
Show More